/**
 * Copyright (c) 2017 Razeware LLC
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * Notwithstanding the foregoing, you may not use, copy, modify, merge, publish,
 * distribute, sublicense, create a derivative work, and/or sell copies of the
 * Software in any work that is designed, intended, or marketed for pedagogical or
 * instructional purposes related to programming, coding, application development,
 * or information technology.  Permission for such use, copying, modification,
 * merger, publication, distribution, sublicensing, creation of derivative works,
 * or sale is expressly withheld.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

import UIKit
import YogaKit

class ViewController: UIViewController {

  override func viewDidLoad() {
    super.viewDidLoad()
    
    self.view.configureLayout{ (layout) in
      layout.isEnabled = true
      layout.width = YGValue(self.view.bounds.size.width)
      layout.height = YGValue(self.view.bounds.size.height)
      layout.alignItems = .center
      layout.justifyContent = .center
    }
    
    let contentView = UIView()
    contentView.backgroundColor = .lightGray
    contentView.configureLayout { (layout) in
      layout.isEnabled = true
      layout.flexDirection = .row
      layout.width = 320
      layout.height = 80
//      layout.marginTop = 40
//      layout.marginLeft = 10
      layout.padding = 10
    }
    self.view.addSubview(contentView)
    
    let child1 = UIView()
    child1.backgroundColor = .red
    child1.configureLayout{ (layout)  in
      layout.isEnabled = true
      layout.width = 80
      layout.marginRight = 10
    }
    contentView.addSubview(child1)
    
    let child2 = UIView()
    child2.backgroundColor = .blue
    child2.configureLayout{ (layout)  in
      layout.isEnabled = true
      layout.width = 80
      layout.flexGrow = 1
      layout.height = 20
      layout.alignSelf = .center
    }
    contentView.addSubview(child2)
    
//    contentView.yoga.applyLayout(preservingOrigin: true)
    self.view.yoga.applyLayout(preservingOrigin: true)
  }
  
  override func viewWillTransition(to size: CGSize, with coordinator: UIViewControllerTransitionCoordinator) {
    super.viewWillTransition(to: size, with: coordinator)
    self.view.configureLayout{ (layout) in
      layout.width = YGValue(size.width)
      layout.height = YGValue(size.height)
    }
    self.view.yoga.applyLayout(preservingOrigin: true)
  }

}

